--[[
       --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--


      #           #   ###########        #######           ####       #         #  ##   ###########        #           #   #   #######      ###########
      #           #   #                  #      ##       ##    ##     ##        #   ##       #             #           #   #   #      ##    #
      #           #   #                  #        #     #        #    # #       #    ##      #             #           #   #   #        #   #
      #     #     #   #                  #         #   #          #   #  ##     #            #             #     #     #   #   #      ##    #
      #     #     #   ###########        #         #   #          #   #    #    #            #             #     #     #   #   #######      ###########
       #   # #   #    #                  #         #   #          #   #     ##  #            #              #   # #   #    #   #            #
       #   # #   #    #                  #        #     #        #    #       # #            #              #   # #   #    #   #            #
        # #   # #     #                  #      ##       ##    ##     #        ##            #               # #   # #     #   #            #
         #     #      ###########        #######           ####       #         #            #                #     #      #   #            ###########


      --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--


                                                             ----o----(||)----o----(||)----o----

                                                                       WINDWALKER MONK
                                                                       ~~~~~~~~~~~~~~~

                                                                   v3.04 25th October 2016
                                                                  Copyright (C) Chris Birch

                                                             ----o----(||)----o----(||)----o----


               Note: This is a module for the We Don't Wipe AddOn. You need to download the latest We Don't Wipe in order to use this module
]]


--[[ ================== ]]--
--[[     Local Data     ]]-- ===============================================================================================================
--[[ ================== ]]-- 

local chiCostLookup = { ["113656"] = 3, ["205320"] = 2, ["107428"] = 2, ["100784"] = 1, ["116847"] = 1, ["101546"] = 3 }
--			Fists of Fury, Strike of the Windlord, Rising Sun Kick, Blackout Kick, Rushing Jade Wind, Spinning Crane Kick

local death, karma, sef, ser, xuen, sefratio, deathratio, uptoyou = "y", "y", "y", "n", "n", 1, 1, -34249
local posFoF, posWDP, cdFoF, cdRSK = 0, 0, 0, 0
local xuenFlag, karmaFlag, rjw, burst, sck = false, false, false, false, false
local playerLevel = 0

local abs = math.abs
local floor = math.floor
local modf = math.modf

local GetMeleeHaste = GetMeleeHaste
local GetTalentInfo = GetTalentInfo
local IsSpellKnown = IsSpellKnown
local IsUsableSpell = IsUsableSpell
local UnitHealth = UnitHealth
local UnitLevel = UnitLevel
local UnitName = UnitName
local UnitPower = UnitPower
local UnitPowerMax = UnitPowerMax

--[[ ======================= ]]--
--[[     Local Functions     ]]-- ==========================================================================================================
--[[ ======================= ]]-- 

local function round( num, places )		-- round to nearest integer, ties round away from zero
	local mult = 10 ^ ( places or 0 )
	return modf( num * mult + ( ( num < 0 and -1 ) or 1 ) * 0.5 ) / mult
end

local function InsertFiller( i, serStartsPos, serExpiresPos )	-- All have ZERO Chi cost ( RJW must have Serenity buff up )

	local cdLeft, pos
	local serenity = ( ( serStartsPos > 0 ) and ( serStartsPos <= i ) and ( i <= serExpiresPos ) ) and true or false

	if ( xuen == "y" ) and ( xuenFlag == false ) and ( select( 4, GetTalentInfo( 6, 2, 1 ) ) == true ) then
		-- Invoke Xuen, the White Tiger (Tier 6 / level 90 Talent)
		cdLeft = WeDontWipe_CooldownLeft( 123904 )
		pos = floor(( cdLeft - wdw_GCD) / wdw_GCDtop) + 1
		if ( pos <= i ) then
			if ( ( i == 1 ) and wdw_mostRecentSpell or wdw_Queue[ i-1 ] ) ~= 123904  then
				wdw_Queue[ i ] = 123904
				xuenFlag = true
				return wdw_Queue[ i ]
			end
		end
	end
	if ( karma == "y" ) and ( karmaFlag == false ) and ( playerLevel >= 55 ) then	-- Touch of Karma
		cdLeft = WeDontWipe_CooldownLeft( 122470 )
		pos = floor(( cdLeft - wdw_GCD) / wdw_GCDtop) + 1
		if ( pos <= i ) then
			if ( ( i == 1 ) and wdw_mostRecentSpell or wdw_Queue[ i-1 ] ) ~= 122470  then
				wdw_Queue[ i ] = 122470
				karmaFlag = true
				return wdw_Queue[ i ]
			end
		end
	end
	if ( serenity == true ) and ( rjw == false ) and ( select( 4, GetTalentInfo( 6, 1, 1 ) ) == true ) then
		-- Rushing Jade Wind (Tier 6 / level 90 Talent)
		cdLeft = WeDontWipe_CooldownLeft( 116847 )
		pos = floor(( cdLeft - wdw_GCD) / wdw_GCDtop) + 1
		if ( pos <= i ) then
			if ( ( i == 1 ) and wdw_mostRecentSpell or wdw_Queue[ i-1 ] ) ~= 116847  then
				wdw_Queue[ i ] = 116847
				rjw = true
				return wdw_Queue[ i ]
			end
		end
	end
	if ( burst == false ) and ( select( 4, GetTalentInfo( 1, 1, 1 ) ) == true ) then
		-- Chi Burst (Tier 1 / level 15 Talent)
		cdLeft = WeDontWipe_CooldownLeft( 123986 )
		pos = floor(( cdLeft - wdw_GCD) / wdw_GCDtop) + 1
		if ( pos <= i ) then
			if ( ( i == 1 ) and wdw_mostRecentSpell or wdw_Queue[ i-1 ] ) ~= 123986  then
				wdw_Queue[ i ] = 123986
				burst = true
				return wdw_Queue[ i ]
			end
		end
	end
	if ( serenity == true ) and ( sck == false ) and ( playerLevel >= 40 ) then	-- Spinning Crane Kick
		cdLeft = WeDontWipe_CooldownLeft( 101546 )
		pos = floor(( cdLeft - wdw_GCD) / wdw_GCDtop) + 1
		if ( pos <= i ) then
			if ( ( i == 1 ) and wdw_mostRecentSpell or wdw_Queue[ i-1 ] ) ~= 101546  then
				wdw_Queue[ i ] = 101546
				sck = true
				return wdw_Queue[ i ]
			end
		end
	end

	wdw_Queue[ i ] = WDW_WindwalkerMonkDB["uptoyou"]
	return wdw_Queue[ i ]
end

local function AddToQueue( spellItemID, expires )

	-- Will insert a spell/item at the first available location, starting from the left-most position consistent with any remaining CD/expiry
	-- expires: the remaining CD or time to expiry (optional). If nil then calculates. If supplied then must be > 0

	-- return codes:	0  = did not add
	--			n  = queue location

	local cdLeft = expires or WeDontWipe_CooldownLeft( spellItemID )

	local pos = floor( ( cdLeft - wdw_GCD) / wdw_GCDtop ) + 1

	for i = pos, WeDontWipeDB.queueLength do
		if ( wdw_Queue[ i ] == 0 ) then
			wdw_Queue[ i ] = spellItemID
			return i
		end
	end

	return 0	
end

--[[ ================ ]]--
--[[     Rotation     ]]-- =================================================================================================================
--[[ ================ ]]-- 

wdwMod_Rotations["Windwalker"] = {}
wdwMod_Rotations["Windwalker"]["Single"] = {			-- Windwalker

	["Version"] = "3.04",
	["WDW Version"] = "5.08",
	["Template"] = "1.05",

	["Rotation"] = {"Setup","ToD","Serenity","SEF","FoF","SotW","RSK","WDP","ChiWave","Blackout","ChiAdjust",},
	["Parameters"] = {"DB", "List", "death", "karma", "sef", "ser", "xuen", "sefratio", "deathratio", "uptoyou"},
	["Notes"] = "Legion Patch 7.1 - Return to Karahzan",

	["uptoyou"] = function (arg)

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "uptoyou".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
					( WDW_WindwalkerMonkDB.uptoyou or "nil").. wdw_colour_Jasmine ..
					" (Specify a spell or item ID obtained from www.wowhead.com. Its ICON will be used. For an ITEM "..
					"make the number negative. "..
					wdw_colour_SelectiveYellow .. "Default \"-34249\"".. wdw_colour_Jasmine.. ", the \"Hula Girl\""..
					" toy item)" )
				return
			end
			WDW_WindwalkerMonkDB["uptoyou"] = tonumber(arg)
		end
		if WDW_WindwalkerMonkDB["uptoyou"] then
			uptoyou = tonumber(WDW_WindwalkerMonkDB["uptoyou"])
		else
			WDW_WindwalkerMonkDB["uptoyou"], uptoyou = -34249, -34249	-- Hula Girl Doll
		end
	end,

	["sefratio"] = function (arg)

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "sefratio".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
					( WDW_WindwalkerMonkDB.sefratio or "nil").. wdw_colour_Jasmine ..
					" (".. wdw_colour_SelectiveYellow.. ">= 0".. wdw_colour_Jasmine..
					wdw_colour_Jasmine.. ". The target's health must be at least this ratio of your full health "..
					"or else Storm, Earth and Fire will be removed from the queue. "..
					wdw_colour_SelectiveYellow .. "Default \"1\"".. wdw_colour_Jasmine.. ". E.g. 0.8 means 0.8 "..
					"or 80% of your maximum health)" )
				return
			end
			WDW_WindwalkerMonkDB[ "sefratio" ] = abs( tonumber( arg ) )
		end
		if WDW_WindwalkerMonkDB[ "sefratio" ] then
			sefratio = tonumber(WDW_WindwalkerMonkDB[ "sefratio" ])
		else
			WDW_WindwalkerMonkDB[ "sefratio" ], sefratio = 1, 1	
		end
	end,

	["deathratio"] = function (arg)

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "deathratio".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
					( WDW_WindwalkerMonkDB.deathratio or "nil").. wdw_colour_Jasmine ..
					" (".. wdw_colour_SelectiveYellow.. ">= 0".. wdw_colour_Jasmine..
					wdw_colour_Jasmine.. ". The target's health must be at least this ratio of your full health or "..
					"else Touch of Death will be removed from the queue. See also \"death\". "..
					wdw_colour_SelectiveYellow .. "Default \"1\"".. wdw_colour_Jasmine.. ". E.g. 1.0 means all or "..
					"100% of your maximum health)" )
				return
			end
			WDW_WindwalkerMonkDB[ "deathratio" ] = abs( tonumber( arg ) )
		end
		if WDW_WindwalkerMonkDB[ "deathratio" ] then
			deathratio = tonumber(WDW_WindwalkerMonkDB[ "deathratio" ])
		else
			WDW_WindwalkerMonkDB[ "deathratio" ], deathratio = 1, 1	
		end
	end,

	["death"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "death".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
					( WDW_WindwalkerMonkDB.death or "nil").. wdw_colour_Jasmine ..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Whether to include Touch of Death. "..
					wdw_colour_SelectiveYellow .. "Default \"y\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_WindwalkerMonkDB[ "death" ] =  ( arg == "y" ) and "y" or "n"
		end
		if not WDW_WindwalkerMonkDB[ "death" ] then
			WDW_WindwalkerMonkDB[ "death" ] = "y"
		end
		death = WDW_WindwalkerMonkDB[ "death" ]
	end,

	["karma"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "karma".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
					( WDW_WindwalkerMonkDB.karma or "nil").. wdw_colour_Jasmine ..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Whether to include Touch of Karma. "..
					wdw_colour_SelectiveYellow .. "Default \"y\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_WindwalkerMonkDB[ "karma" ] =  ( arg == "y" ) and "y" or "n"
		end
		if not WDW_WindwalkerMonkDB[ "karma" ] then
			WDW_WindwalkerMonkDB[ "karma" ] = "y"
		end
		karma = WDW_WindwalkerMonkDB[ "karma" ]
	end,

	["sef"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "sef".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
					( WDW_WindwalkerMonkDB.sef or "nil").. wdw_colour_Jasmine ..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Whether to include Storm, Earth and Fire. "..
					wdw_colour_SelectiveYellow .. "Default \"y\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_WindwalkerMonkDB[ "sef" ] =  ( arg == "y" ) and "y" or "n"
		end
		if not WDW_WindwalkerMonkDB[ "sef" ] then
			WDW_WindwalkerMonkDB[ "sef" ] = "y"
		end
		sef = WDW_WindwalkerMonkDB[ "sef" ]
	end,

	["ser"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "ser".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
					( WDW_WindwalkerMonkDB.ser or "nil").. wdw_colour_Jasmine ..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Whether to include Serenity. "..
					wdw_colour_SelectiveYellow .. "Default \"n\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_WindwalkerMonkDB[ "ser" ] =  ( arg == "y" ) and "y" or "n"
		end
		if not WDW_WindwalkerMonkDB[ "ser" ] then
			WDW_WindwalkerMonkDB[ "ser" ] = "n"
		end
		ser = WDW_WindwalkerMonkDB[ "ser" ]
	end,

	["xuen"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "xuen".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
					( WDW_WindwalkerMonkDB.xuen or "nil").. wdw_colour_Jasmine ..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Whether to include Invoke Xuen. "..
					wdw_colour_SelectiveYellow .. "Default \"n\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_WindwalkerMonkDB[ "xuen" ] =  ( arg == "y" ) and "y" or "n"
		end
		if not WDW_WindwalkerMonkDB[ "xuen" ] then
			WDW_WindwalkerMonkDB[ "xuen" ] = "n"
		end
		xuen = WDW_WindwalkerMonkDB[ "xuen" ]
	end,

	["DB"] = function ()

		if not WDW_WindwalkerMonkDB then WDW_WindwalkerMonkDB = {} return end

		if ( WDW_WindwalkerMonkDB.touch ~= nil ) then
			WDW_WindwalkerMonkDB.death = WDW_WindwalkerMonkDB.touch
			WDW_WindwalkerMonkDB.touch = nil
		end
		if ( WDW_WindwalkerMonkDB.touchratio ~= nil ) then
			WDW_WindwalkerMonkDB.deathratio = WDW_WindwalkerMonkDB.touchratio
			WDW_WindwalkerMonkDB.touchratio = nil
		end
	end,

	["List"] = function ()

		print( wdw_colour_SelectiveYellow.. "Windwalker Monk parameters:\n"..
			wdw_colour_MalachiteGreen.. "death".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
				( death or "nil" ).. wdw_colour_Jasmine .. ", ".. 
			wdw_colour_MalachiteGreen.. "karma".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
				( karma or "nil" ).. wdw_colour_Jasmine .. ", ".. 
			wdw_colour_MalachiteGreen.. "sef".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
				( sef or "nil" ).. wdw_colour_Jasmine .. ", ".. 
			wdw_colour_MalachiteGreen.. "ser".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
				( ser or "nil" ).. wdw_colour_Jasmine .. ", ".. 
			wdw_colour_MalachiteGreen.. "xuen".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
				( xuen or "nil" ).. wdw_colour_Jasmine .. ", ".. 
			wdw_colour_MalachiteGreen.. "sefratio".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
				( sefratio or "nil" ).. wdw_colour_Jasmine .. ", ".. 
			wdw_colour_MalachiteGreen.. "deathratio".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
				( deathratio or "nil" ).. wdw_colour_Jasmine .. ", ".. 
			wdw_colour_MalachiteGreen.. "uptoyou".. wdw_colour_Jasmine .. "=".. wdw_colour_SelectiveYellow..
				( uptoyou or "nil" ) ) 
	end,

	["Setup"] = function ()

		playerLevel = UnitLevel( "player" )

		cdFoF = ( playerLevel >= 20 ) and WeDontWipe_CooldownLeft( 113656 ) or 0	-- Fists of Fury
		cdRSK = WeDontWipe_CooldownLeft( 107428 ) or 0					-- Rising Sun Kick. Level 10

		posFoF, posWDP = 0, 0
		xuenFlag, karmaFlag, rjw, burst, sck = false, false, false, false, false
	end,

	["ToD"] = function () -- Touch of Death (120s CD). From level 24. 8s delay plus a GCD

		if ( playerLevel < 32 ) or ( death == "n" ) then return end

		if UnitName( "target" ) then
			if UnitHealth( "target" ) >= ( deathratio * UnitHealth( "player" ) ) then
				AddToQueue( 115080 )
			end
		end
	end,

	["Serenity"] = function () -- Serenity. Level 100. 1.5m CD. No GCD. Lasts 8s - free Chi and 50% reduced CD on Chi consuming spells

		if ( ser == "y" ) and ( select( 4, GetTalentInfo( 7, 3, 1 ) ) == true ) then
			AddToQueue( 152173 )
		end

		-- Could get fancy and avoid using during Bloodlust and similar but then use at the end for an extended burst
	end,

--	Note: Blizzard have thankfully (from the point of view of writing this AddOn) made having Serenity and SEF mutually exclusive

	["SEF"] = function () -- Storm, Earth and Fire (1s CD). From level 65. Lasts 15s. 2 charges, 1.5m recharge

		if ( playerLevel < 50 ) or ( sef == "n" ) then return end

		if UnitName( "target" ) then
			if UnitHealth( "target" ) >= ( sefratio * UnitHealth( "player" ) ) then
				local currentCharges, maxCharges, cooldownStart, cooldownDuration = GetSpellCharges( 137639 )
				if ( currentCharges > 1 ) or ( ( currentCharges == 1 ) and ( maxCharges == 1 ) ) then
					local pos = AddToQueue( 137639, 0 )
					if ( ( pos - 1 ) * wdw_GCDtop + wdw_GCD + 15 ) > cdFoF then
						wdw_Queue[ pos ] = 0
						AddToQueue( 137639, cdFoF )
					end
				else
					if ( currentCharges == 1 ) then
						if wdw_buffsPlayer[ "137639" ] and ( wdw_buffsPlayer[ "137639" ].expires > cdFoF ) then
							-- player a little out of step with FoF. Will get a little overlap though
						else
							-- How we want it. Nice
							AddToQueue( 137639, cdFoF )
						end
					else
						if ( cooldownStart + cooldownDuration - GetTime() ) <= cdFoF then
							AddToQueue( 137639, cdFoF )
						else
							-- This will happen a lot as the 90s CD is much greater than the 24s CD of FoF
						end
					end
				end
			end
		end
	end,

	["FoF"] = function () -- Fists of Fury. Level 28. COST 3 Chi. 24s CD. Lasts 4s - channel. GCD 1s

		if ( playerLevel < 20 ) then return end
		posFoF = AddToQueue( 113656, cdFoF )

		-- Review Serenity and FoF. Are minmaxers concerned that FoF could use half of Serenity's 8s buff?
	end,

	["SotW"] = function () -- Strike of the Windlord. GCD, Lasts 6s. 40s CD

		if not IsSpellKnown( 205320 ) then return end
		if IsUsableSpell( 205320 ) then
			AddToQueue( 205320 )
		end
	end,

	["RSK"] = function () -- Rising Sun Kick. Level 18. COST 2 Chi. 1.5s GCD. 10s recharge, 1 charge

		if ( playerLevel < 10 ) then return end
		posRSK = AddToQueue( 107428 )
	end,

	["WDP"] = function () -- Whirling Dragon Punch. Level 100 talent. 24s CD, GCD. FoF and RSK must both be on CD

		if ( select( 4, GetTalentInfo( 7, 2, 1 ) ) == false ) then return end

		local earliestPosFoF, latestPosFoF
		if ( cdFoF > 0 ) then
			latestPosFoF = floor(( cdFoF - wdw_GCD) / wdw_GCDtop) + 1
			if ( posFoF > 0 ) then
				earliestPosFoF = posFoF
			else
				earliestPosFoF = 0
			end
		else
			latestPosFoF = 0
			if ( posFoF > 0 ) then
				earliestPosFoF = posFoF
			else
				earliestPosFoF = WeDontWipeDB.queueLength
			end
		end

		local earliestPosRSK, latestPosRSK
		if ( cdRSK > 0 ) then
			latestPosRSK = floor(( cdRSK - wdw_GCD) / wdw_GCDtop) + 1
			if ( posRSK > 0 ) then
				earliestPosRSK = posRSK
			else
				earliestPosRSK = 0
			end
		else
			latestPosRSK = 0
			if ( posRSK > 0 ) then
				earliestPosRSK = posRSK
			else
				earliestPosRSK = WeDontWipeDB.queueLength
			end
		end

		local latestPos = ( latestPosFoF < latestPosRSK ) and latestPosFoF or latestPosRSK
		local earliestPos = ( earliestPosFoF > earliestPosRSK ) and earliestPosFoF or earliestPosRSK
		local cdLeft = WeDontWipe_CooldownLeft( 152175 )
		local earliestWDP = floor(( cdLeft - wdw_GCD) / wdw_GCDtop) + 1

		if ( latestPos < earliestPos ) then
			local pos = 0
			for i = earliestWDP, latestPos, 1 do
				if ( wdw_Queue[ i ] == 0 ) then
					wdw_Queue[ i ] = 152175						-- WDP
					pos = i
					break
				end
			end
			if ( pos == 0 ) then
				earliestPos = ( earliestWDP > earliestPos ) and earliestWDP or earliestPos
				for i = earliestPos, WeDontWipeDB.queueLength, 1 do
					if ( wdw_Queue[ i ] == 0 ) then
						wdw_Queue[ i ] = 152175					-- WDP
						break
					end
				end
			end
		else
			earliestPos = ( earliestWDP > earliestPos ) and earliestWDP or earliestPos
			for i = earliestPos, WeDontWipeDB.queueLength do
				if ( wdw_Queue[ i ] == 0 ) then
					wdw_Queue[ i ] = 152175
					break
				end
			end
		end
	end,

	["ChiWave"] = function () -- Chi Wave. Level 15. 15s CD, GCD

		if ( select( 4, GetTalentInfo( 1, 3, 1 ) ) == true ) then
			AddToQueue( 115098 )
		end
	end,

	["Blackout"] = function () -- Blackout Kick. Level 3. 3s CD, GCD. COST 1 Chi

		if ( playerLevel < 3 ) then return end

		if ( wdw_mostRecentSpell == 100784 ) then
			local cdLeft = WeDontWipe_CooldownLeft( 100784 )
			if ( cdLeft == 0 ) then
				AddToQueue( 100784, wdw_GCDtop ) -- Force away from pos #1
			else
				AddToQueue( 100784, cdLeft )
			end
		else
			AddToQueue( 100784 )
		end
	end,

	["ChiAdjust"] = function ()

		-- To here with rotation optimally placed but DISREGARDING Chi and Energy
		-- In MoP, WoD and now in Legion, despite a rather varying meta for WW, we have managed to avoid the need to
		-- chug in order to replenish Energy or Chi.

		-- Preliminary Serenity calculations. When will Chi will be free?

		local serStartsPos, serExpiresPos = 0, 0
		if wdw_buffsPlayer[ "152173" ] then
			serStartsPos = 1
			serExpiresPos = floor( ( wdw_buffsPlayer[ "152173" ].expires - wdw_GCD ) / wdw_GCDtop ) + 1
		end

		-- Insert Tiger Palms to ensure sufficient Chi for queued spells
		-- We do not get the Mastery: Combo Strikes buff if we use the same ability twice in a row
		-- Fill in all gaps / separate consecutive spell uses. None of the fillers use Chi/Energy
		-- BUT avoid inserting a TP if too little energy/Chi

		local chiCurrent = UnitPower( "player", SPELL_POWER_CHI )
		local chiMax = UnitPowerMax( "player", SPELL_POWER_CHI )
		local toBeMovedUp, insertThis, filler, chiCost

		-- While testing, Ascension didn't show up in the Spellbook, and IsSpellKnown(115396) always returned false
		-- v3.03 solved the problem for all talents but as this code works, we'll stick with it
		local energyPerSec = 10 + round( GetMeleeHaste(), 3 ) / 10
		energyPerSec = ( chiMax == 6 ) and ( energyPerSec * 1.1 ) or energyPerSec	-- Ascension Talent

		local energyCurrent = UnitPower( "player", SPELL_POWER_ENERGY ) + ( wdw_GCD * energyPerSec )
		local energyHigh = 100 - ( 2 * energyPerSec )

		for i = 1, WeDontWipeDB.queueLength do

			if ( wdw_Queue[ i ] == 0 ) then

				if ( chiCurrent < chiMax ) and ( energyCurrent >= energyHigh ) and
						( ( ( i == 1 ) and wdw_mostRecentSpell or wdw_Queue[ i-1 ] ) ~= 100780 ) then
					wdw_Queue[ i ] = 100780
				else
					filler = InsertFiller( i, serStartsPos, serExpiresPos )
				end
				chiCost = 0

			elseif ( wdw_Queue[ i ] == ( ( i == 1 ) and wdw_mostRecentSpell or wdw_Queue[ i-1 ] ) ) then
				insertThis = wdw_Queue[ i ]
				for j = (i+1), WeDontWipeDB.queueLength, 1 do
					toBeMovedUp =  wdw_Queue[ j ]
					wdw_Queue[ j ] = insertThis
					if ( toBeMovedUp == 0 ) then break end
					insertThis = toBeMovedUp
				end
				if ( chiCurrent < chiMax ) and ( energyCurrent >= energyHigh ) then
					wdw_Queue[ i ] = 100780					-- Tiger Palm
				else
					InsertFiller( i, serStartsPos, serExpiresPos )
				end
				chiCost = 0

			elseif ( serStartsPos > 0 ) and ( serStartsPos <= i ) and ( i <= serExpiresPos ) then
				chiCost = 0
			elseif ( wdw_Queue[ i ] == 152173 ) then				-- Serenity
				serStartsPos = i
				serExpiresPos = floor( 8 / wdw_GCDtop ) + 1 + i
				chiCost = 0

			else
				if ( wdw_Queue[ i ] == 100784 ) then				-- Blackout Kick
					if wdw_buffsPlayer[ "116768" ] then			-- Blackout Kick Buff
						local bkExpiresPos = floor( ( wdw_buffsPlayer[ "116768" ].expires - wdw_GCD ) / wdw_GCDtop ) + 1
						if ( bkExpiresPos < i ) then
							chiCost = chiCostLookup[ "100784" ]
						else
							chiCost = 0
						end
					else
						chiCost = chiCostLookup[ "100784" ]
					end
				else
					chiCost = chiCostLookup[ tostring( wdw_Queue[ i ] ) ] or 0
				end
				if ( chiCurrent < chiCost ) then
					insertThis = wdw_Queue[ i ]
					for j = ( i + 1), WeDontWipeDB.queueLength, 1 do
						toBeMovedUp =  wdw_Queue[ j ]
						wdw_Queue[ j ] = insertThis
						if ( toBeMovedUp == 0 ) then break end
						insertThis = toBeMovedUp
					end
					if ( energyCurrent >= energyHigh ) and ( ( ( i == 1 ) and wdw_mostRecentSpell or wdw_Queue[ i-1 ] ) ~= 100780 ) then
						wdw_Queue[ i ] = 100780					-- Tiger Palm
					else
						InsertFiller( i, serStartsPos, serExpiresPos )
					end
					chiCost = 0
				end
			end

			if ( wdw_Queue[ i ] == 100780 ) then					-- Tiger Palm
				chiCurrent = chiCurrent + 2
				chiCurrent = ( chiCurrent <= chiMax ) and chiCurrent or chiMax
			else
				chiCurrent = chiCurrent - chiCost 
			end

			energyCurrent = energyCurrent + ( wdw_GCDtop * energyPerSec )
		end
	end,
}